Attribute VB_Name = "ModChess"
Option Explicit

Public Const colBoardMain = 14
Public Const rowBoardMain = 9

Public Const countRank As Byte = 8
Public Const countFile As Byte = 8

Public Const ascRank0 As Byte = 48
Public Const ascRank1 As Byte = 49
Public Const ascFileA As Byte = 97
Public Const ascFileH As Byte = 104

Public Const a8 As Byte = &HB4, b8 As Byte = &HB5, c8 As Byte = &HB6, d8 As Byte = &HB7
Public Const a7 As Byte = &HA4, b7 As Byte = &HA5, c7 As Byte = &HA6, d7 As Byte = &HA7
Public Const a6 As Byte = &H94, b6 As Byte = &H95, c6 As Byte = &H96, d6 As Byte = &H97
Public Const a5 As Byte = &H84, b5 As Byte = &H85, c5 As Byte = &H86, d5 As Byte = &H87
Public Const a4 As Byte = &H74, b4 As Byte = &H75, c4 As Byte = &H76, d4 As Byte = &H77
Public Const a3 As Byte = &H64, b3 As Byte = &H65, c3 As Byte = &H66, d3 As Byte = &H67
Public Const a2 As Byte = &H54, b2 As Byte = &H55, c2 As Byte = &H56, d2 As Byte = &H57
Public Const a1 As Byte = &H44, b1 As Byte = &H45, c1 As Byte = &H46, d1 As Byte = &H47

Public Const e8 As Byte = &HB8, f8 As Byte = &HB9, g8 As Byte = &HBA, h8 As Byte = &HBB
Public Const e7 As Byte = &HA8, f7 As Byte = &HA9, g7 As Byte = &HAA, h7 As Byte = &HAB
Public Const e6 As Byte = &H98, f6 As Byte = &H99, g6 As Byte = &H9A, h6 As Byte = &H9B
Public Const e5 As Byte = &H88, f5 As Byte = &H89, g5 As Byte = &H8A, h5 As Byte = &H8B
Public Const e4 As Byte = &H78, f4 As Byte = &H79, g4 As Byte = &H7A, h4 As Byte = &H7B
Public Const e3 As Byte = &H68, f3 As Byte = &H69, g3 As Byte = &H6A, h3 As Byte = &H6B
Public Const e2 As Byte = &H58, f2 As Byte = &H59, g2 As Byte = &H5A, h2 As Byte = &H5B
Public Const e1 As Byte = &H48, f1 As Byte = &H49, g1 As Byte = &H4A, h1 As Byte = &H4B

Public Const fileA As Byte = &H4, fileB As Byte = &H5, fileC As Byte = &H6
Public Const fileD As Byte = &H7, fileE As Byte = &H8, fileF As Byte = &H9
Public Const fileG As Byte = &HA, fileH As Byte = &HB

Public Const rank1 As Byte = &H4, rank2 As Byte = &H5, rank3 As Byte = &H6
Public Const rank4 As Byte = &H7, rank5 As Byte = &H8, rank6 As Byte = &H9
Public Const rank7 As Byte = &HA, rank8 As Byte = &HB

Public Const pawnWhiteAttackRightOffset = 17
Public Const pawnWhiteAttackLeftOffset = 15
Public Const pawnBlackAttackRightOffset = -15
Public Const pawnBlackAttackLeftOffset = -17

Public Const typeKing As Byte = 1
Public Const typeQueen As Byte = typeKing + 1
Public Const typeRook As Byte = typeQueen + 1
Public Const typeBishop As Byte = typeRook + 1
Public Const typeKnight As Byte = typeBishop + 1
Public Const typePawn As Byte = typeKnight + 1

Public Const valuePawn = 100
Public Const valueKnight = 300
Public Const valueBishop = 325
Public Const valueRook = 500
Public Const valueQueen = 975
Public Const valueKing = 1000

Public Const moveTypeNull As Byte = 0
Public Const moveStandard As Byte = moveTypeNull + 1
Public Const movePromotionQueen As Byte = moveStandard + 1
Public Const movePromotionRook As Byte = movePromotionQueen + 1
Public Const movePromotionBishop As Byte = movePromotionRook + 1
Public Const movePromotionKnight As Byte = movePromotionBishop + 1
Public Const moveEnPassant As Byte = movePromotionKnight + 1
Public Const moveCastleQueenSide As Byte = moveEnPassant + 1
Public Const moveCastleKingSide As Byte = moveCastleQueenSide + 1

Public Const statusNormal As Byte = 1
Public Const statusInCheck As Byte = statusNormal + 1
Public Const statusDrawStaleMate As Byte = statusInCheck + 1
Public Const statusInCheckMate As Byte = statusDrawStaleMate + 1

Const colorFillRed = 3
Const colorFillGreen = 10
Public Const colorFillBlue = 34
Const colorFillLightGreen = 35
Public Const colorFillYellow = 36
Const colorFillPaleBlue = 37
Const colorFillPink = 38
Const colorFillPurple = 39
Public Const colorFillBeige = 40
Const colorFillAqua = 42
Const colorFillLime = 43
Const colorFillGold = 44
Public Const colorFillGray = 48
Public Const colorFillSeaGreen = 50
Public Const colorFillStripped = xlNone
Const colorFillOrange = 45

Const WhiteSquare = " "
Const BlackSquare = "+"

Const BlackPawnW = "o"
Const BlackPawnB = "O"
Const BlackkNightW = "m"
Const BlackkNightB = "M"
Const BlackBishopW = "v"
Const BlackBishopB = "V"
Const BlackRookW = "t"
Const BlackRookB = "T"
Const BlackQueenW = "w"
Const BlackQueenB = "W"
Const BlackKingW = "l"
Const BlackKingB = "L"

Const BlackPieceSymbol = BlackKingB + BlackQueenB + BlackRookB + _
                         BlackBishopB + BlackkNightB + BlackPawnB

Public Const strAbbreviationPiecesEn = "KQRBNP"
Public Const strAbbreviationPiecesFr = "RDTFCP"

Public boardMain As Board
Public isFrench As Boolean
Public colorSquareBlack As Integer
Public isColorSquareBlackChanged As Boolean

Function FileFromOrdinal(ByVal ordSqr As Byte) As Byte
    FileFromOrdinal = ordSqr And &HF
End Function

Function RankFromOrdinal(ByVal ordSqr As Byte) As Byte
    RankFromOrdinal = ordSqr \ 16
End Function

Public Function FileFromName(ByVal strNameFile As String) As Byte
Dim indFile As Byte

    indFile = Asc(strNameFile) - ascFileA + fileA
    If indFile < fileA Or indFile > fileH Then
        FileFromName = 0
    Else
        FileFromName = indFile
    End If
End Function

Public Function RankFromName(ByVal strNameRank As String) As Byte
Dim indRank As Byte

    indRank = Asc(strNameRank) - ascRank1 + rank1
    If indRank < rank1 Or indRank > rank8 Then
        RankFromName = 0
    Else
        RankFromName = indRank
    End If
End Function

Function FileToString(ByVal indFile As Byte) As String
    FileToString = Chr(ascFileA + indFile - fileA)
End Function

Function RankToString(ByVal indRank As Byte) As String
    RankToString = Chr(ascRank1 + indRank - rank1)
End Function

Function OrdinalFromFileRank(ByVal indFile As Byte, ByVal indRank As Byte) As Byte
    OrdinalFromFileRank = indRank * 16 Or indFile
End Function

Function NamePiece(ByVal typeOfPiece As Byte) As String
    If typeOfPiece >= typeKing And typeOfPiece <= typePawn Then
        NamePiece = Mid(strAbbreviationPiecesEn, typeOfPiece, 1)
    Else
        ErrWarn 3200
    End If
End Function

Function AbbrToTypePiece(ByVal strPiece As String, ByRef typeOfPiece As Byte) As Boolean
    typeOfPiece = InStr(strAbbreviationPiecesEn, strPiece)
    AbbrToTypePiece = typeOfPiece > 0
End Function

Sub ErrWarn(ByVal indCode As Integer)
Dim strMsg As String

    strMsg = "Warning " + CStr(indCode)
    MsgBox strMsg, vbExclamation, "Chess warning "
    
End Sub

Sub GuiPiecePinnedHide()

End Sub

Sub GuiDisplayBoardAt(ByVal isSideWhite As Boolean, ByVal indRow As Integer, _
                        ByVal indCol As Integer, chessBoard As Board)
Dim indRank As Byte, indFile As Byte, cellSqr As Range
Dim strSquare As String
Dim sqr As Square, pieceThis As Piece, isSqrWhite As Boolean, indEdge As Byte

    For indRank = 0 To 7
        If isSideWhite Then
            Cells(indRow + 1, indRank + indCol) = Chr(ascFileA + indRank)
            Cells(indRow - indRank, indCol - 1) = indRank + 1
        Else
            Cells(indRow + 1, indRank + indCol) = Chr(ascFileH - indRank)
            Cells(indRow + indRank - 7, indCol - 1) = indRank + 1
        End If
        For indFile = 0 To 7
            Set cellSqr = IIf(isSideWhite, Cells(indRow - indRank, indCol + indFile), _
                Cells(indRow + indRank - 7, indCol - indFile + 7))
            isSqrWhite = (indFile And 1) Xor (indRank And 1)
            If chessBoard Is Nothing Then
                strSquare = IIf(colorSquareBlack = colorFillStripped And Not isSqrWhite, BlackSquare, WhiteSquare)
                cellSqr.Select
                GuiPiecePinnedHide
                Selection.Interior.ColorIndex = IIf(isSqrWhite, xlNone, colorSquareBlack)
            ElseIf isColorSquareBlackChanged Then
                strSquare = IIf(colorSquareBlack = colorFillStripped And Not isSqrWhite, BlackSquare, WhiteSquare)
                If Not isSqrWhite Then
                    cellSqr.Select
                    Selection.Interior.ColorIndex = colorSquareBlack
                End If
            End If
            If Not chessBoard Is Nothing Then
                Set sqr = chessBoard.GetSquareFileRank(indFile + fileA, indRank + rank1)
                Set pieceThis = sqr.PieceOnSquare
                If pieceThis Is Nothing Then
                    strSquare = IIf(colorSquareBlack = colorFillStripped And Not sqr.isWhite, BlackSquare, WhiteSquare)
                Else
                    strSquare = Mid(IIf(pieceThis.isWhite, strAbbreviationPiecesEn, BlackPieceSymbol), pieceThis.TypePiece, 1)
                    If colorSquareBlack <> colorFillStripped Or sqr.isWhite Then
                        strSquare = LCase(strSquare)
                    End If
                End If
            End If
            cellSqr.Value = strSquare
        Next
    Next
End Sub

